routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
/*
Route::get('/', function () {
    return view('auth.login');
});
*/
//Auth::routes();
//Route::get('/home', 'HomeController@index')->name('home');


Auth::routes();

//Route::get('/home', 'HomeController@index');

Route::group(['middleware' => 'auth'], function () {
    Route::get('/home', 'HomeController@index')->name('home');

    Route::resource('cities', 'CityController');
    Route::view('cities/browse/file', 'cities.upload'); //only in laravel 5.5
    Route::post('cities/upload', ['uses' => 'CityController@upload']);
    Route::post('cities/download', ['uses' => 'CityController@download']);

    Route::resource('districts', 'DistrictController');
    Route::view('districts/browse/file', 'districts.upload');
    Route::post('districts/upload', ['uses' => 'DistrictController@upload']);
    Route::post('districts/download', ['uses' => 'DistrictController@download']);

    Route::resource('microDistricts', 'MicroDistrictController');
    Route::view('microDistricts/browse/file', 'micro_districts.upload');
    Route::post('microDistricts/upload', ['uses' => 'MicroDistrictController@upload']);
    Route::post('microDistricts/download', ['uses' => 'MicroDistrictController@download']);

    //Route::group(['middleware' => ['role:admin']], function () {
        Route::resource('dealTypes', 'DealTypeController');

        Route::resource('objectTypes', 'ObjectTypeController');
    //});

    Route::resource('objects', 'ObjectController');
    Route::view('objects/browse/file', 'objects.upload');
    Route::post('objects/upload', ['uses' => 'ObjectController@upload']);
    Route::post('objects/download', ['uses' => 'ObjectController@download']);


    Route::resource('roles', 'RoleController');

    Route::resource('users', 'UserController');
});





Route::resource('logs', 'LogController');

Route::resource('developers', 'DeveloperController');

app/Models/MicroDistrict.php
<?php

namespace App\Models;

use Eloquent as Model;

/**
 * Class MicroDistrict
 * @package App\Models
 * @version June 8, 2018, 12:43 pm UTC
 *
 * @property integer district_id
 * @property integer micro_district_id
 * @property string name
 * @property string translit
 * @property string roditelniy
 * @property string predlozhniy
 */
class MicroDistrict extends Model
{

    public $table = 'microdistricts';
    
    const CREATED_AT = 'created_at';
    const UPDATED_AT = 'updated_at';



    public $fillable = [
        'district_id',
        'micro_district_id',
        'name',
        'translit',
        'roditelniy',
        'predlozhniy'
    ];

    /**
     * The attributes that should be casted to native types.
     *
     * @var array
     */
    protected $casts = [
        'id' => 'integer',
        'district_id' => 'integer',
        'micro_district_id' => 'integer',
        'name' => 'string',
        'translit' => 'string',
        'roditelniy' => 'string',
        'predlozhniy' => 'string'
    ];

    /**
     * Validation rules
     *
     * @var array
     */
    public static $rules = [
        'name' => 'required',
        'micro_district_id' => 'required',
    ];

    public function microdistrictObjects()
    {
        return $this->hasMany(\App\Models\Object::class, 'micro_district_id', 'micro_district_id');
    }

    public function districtMicrodistrict()
    {
        return $this->belongsTo(\App\Models\District::class, 'district_id', 'district_id');
    }
    
}

app/Http/Controllers/MicroDistrictController.php
<?php

namespace App\Http\Controllers;

use App\DataTables\MicroDistrictDataTable;
use App\Http\Requests;
use App\Http\Requests\CreateMicroDistrictRequest;
use App\Http\Requests\UpdateMicroDistrictRequest;
use App\Models\MicroDistrict;
use App\Repositories\MicroDistrictRepository;
use Flash;
use App\Http\Controllers\AppBaseController;
use Response;
use Illuminate\Http\Request;

class MicroDistrictController extends AppBaseController
{
    /** @var  MicroDistrictRepository */
    private $microDistrictRepository;

    public function __construct(MicroDistrictRepository $microDistrictRepo)
    {
        $this->microDistrictRepository = $microDistrictRepo;
    }

    /**
     * Display a listing of the MicroDistrict.
     *
     * @param MicroDistrictDataTable $microDistrictDataTable
     * @return Response
     */
    public function index(MicroDistrictDataTable $microDistrictDataTable)
    {
        return $microDistrictDataTable->render('micro_districts.index');
    }

    /**
     * Show the form for creating a new MicroDistrict.
     *
     * @return Response
     */
    public function create()
    {
        //return view('micro_districts.create');
        $districts = $this->microDistrictRepository->getDistricts();
        return view('micro_districts.create',compact('districts'));
    }

    /**
     * Store a newly created MicroDistrict in storage.
     *
     * @param CreateMicroDistrictRequest $request
     *
     * @return Response
     */
    public function store(CreateMicroDistrictRequest $request)
    {
        $input = $request->all();

        $microDistrict = $this->microDistrictRepository->create($input);

        Flash::success('Micro District saved successfully.');

        return redirect(route('microDistricts.index'));
    }

    /**
     * Display the specified MicroDistrict.
     *
     * @param  int $id
     *
     * @return Response
     */
    public function show($id)
    {
        $microDistrict = $this->microDistrictRepository->findWithoutFail($id);

        if (empty($microDistrict)) {
            Flash::error('Micro District not found');

            return redirect(route('microDistricts.index'));
        }

        return view('micro_districts.show')->with('microDistrict', $microDistrict);
    }

    /**
     * Show the form for editing the specified MicroDistrict.
     *
     * @param  int $id
     *
     * @return Response
     */
    public function edit($id)
    {
        $microDistrict = $this->microDistrictRepository->findWithoutFail($id);

        if (empty($microDistrict)) {
            Flash::error('Micro District not found');

            return redirect(route('microDistricts.index'));
        }

        $districts = $this->microDistrictRepository->getDistricts();
        return view('micro_districts.edit',compact('microDistrict','districts'));
        //return view('micro_districts.edit')->with('microDistrict', $microDistrict);
    }

    /**
     * Update the specified MicroDistrict in storage.
     *
     * @param  int              $id
     * @param UpdateMicroDistrictRequest $request
     *
     * @return Response
     */
    public function update($id, UpdateMicroDistrictRequest $request)
    {
        $microDistrict = $this->microDistrictRepository->findWithoutFail($id);

        if (empty($microDistrict)) {
            Flash::error('Micro District not found');

            return redirect(route('microDistricts.index'));
        }

        $microDistrict = $this->microDistrictRepository->update($request->all(), $id);

        Flash::success('Micro District updated successfully.');

        return redirect(route('microDistricts.index'));
    }

    /**
     * Remove the specified MicroDistrict from storage.
     *
     * @param  int $id
     *
     * @return Response
     */
    public function destroy($id)
    {
        $microDistrict = $this->microDistrictRepository->findWithoutFail($id);

        if (empty($microDistrict)) {
            Flash::error('Micro District not found');

            return redirect(route('microDistricts.index'));
        }

        $relatedObjects =MicroDistrict::has('microdistrictObjects')->where('id',$id)->count();
        if($relatedObjects){
            Flash::error('Сначала удалите  объекты, связанные с этим микрорайоном');
            return redirect(route('microDistricts.index'));
        }
        else {
            $this->microDistrictRepository->delete($id);
            Flash::success('Micro District deleted successfully.');
            return redirect(route('microDistricts.index'));
        }
    }

    public function upload(Request $request)
    {
        $file = $request->file('microDistricts');

        $microdistricts = $this->microDistrictRepository->getModel();//$city=new City();
        $arr=$microdistricts->fillable;

        $required=['name','micro_district_id'];
        $foreign_key=['district_id'];

        return $this->uploadFile($file, 'microDistricts', $microdistricts, $foreign_key, $arr, $required);
    }

    public function download()
    {
        $microdistricts=MicroDistrict::get();

        return $this->downloadFile($microdistricts,  'Micro_district');
    }
}

resources/views/micro_districts/create.blade.php
@extends('layouts.app')

@section('content')
    <section class="content-header">
        <h1>
            Микрорайоны
        </h1>
    </section>
    <div class="content">
        @include('adminlte-templates::common.errors')
        <div class="box box-primary">

            <div class="box-body">
                <div class="row">
                    {!! Form::open(['route' => 'microDistricts.store']) !!}

                        @include('micro_districts.fields')

                    {!! Form::close() !!}
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/micro_districts/datatables_actions.blade.php
{!! Form::open(['route' => ['microDistricts.destroy', $id], 'method' => 'delete']) !!}
<div class='btn-group'>
    <a href="{{ route('microDistricts.show', $id) }}" class='btn btn-default btn-xs'>
        <i class="glyphicon glyphicon-eye-open"></i>
    </a>
    <a href="{{ route('microDistricts.edit', $id) }}" class='btn btn-default btn-xs'>
        <i class="glyphicon glyphicon-edit"></i>
    </a>
    {!! Form::button('<i class="glyphicon glyphicon-trash"></i>', [
        'type' => 'submit',
        'class' => 'btn btn-danger btn-xs',
        'onclick' => "return confirm('Are you sure?')"
    ]) !!}
</div>
{!! Form::close() !!}

resources/views/micro_districts/edit.blade.php
@extends('layouts.app')

@section('content')
    <section class="content-header">
        <h1>
            Микрорайоны
        </h1>
   </section>
   <div class="content">
       @include('adminlte-templates::common.errors')
       <div class="box box-primary">
           <div class="box-body">
               <div class="row">
                   {!! Form::model($microDistrict, ['route' => ['microDistricts.update', $microDistrict->id], 'method' => 'patch']) !!}

                        @include('micro_districts.fields')

                   {!! Form::close() !!}
               </div>
           </div>
       </div>
   </div>
@endsection

resources/views/micro_districts/fields.blade.php
<!-- District Id Field -->
<div class="form-group col-sm-6">
    {!! Form::label('district', 'Район:') !!}
    @isset($microdistrict['city_id'])
        {!!Form::select('district_id', $districts, $microdistrict['district_id'], ['class' => 'form-control'])!!}
    @else
        {!!Form::select('district_id', $districts, null, ['class' => 'form-control'])!!}
    @endisset
</div>

<!-- Micro District Id Field -->
<div class="form-group col-sm-6">
    {!! Form::label('micro_district_id', 'Micro District Id:') !!}
    {!! Form::number('micro_district_id', null, ['class' => 'form-control']) !!}
</div>

<!-- Name Field -->
<div class="form-group col-sm-6">
    {!! Form::label('name', 'Name:') !!}
    {!! Form::text('name', null, ['class' => 'form-control']) !!}
</div>

<!-- Translit Field -->
<div class="form-group col-sm-6">
    {!! Form::label('translit', 'Translit:') !!}
    {!! Form::text('translit', null, ['class' => 'form-control']) !!}
</div>

<!-- Roditelniy Field -->
<div class="form-group col-sm-6">
    {!! Form::label('roditelniy', 'Roditelniy:') !!}
    {!! Form::text('roditelniy', null, ['class' => 'form-control']) !!}
</div>

<!-- Predlozhniy Field -->
<div class="form-group col-sm-6">
    {!! Form::label('predlozhniy', 'Predlozhniy:') !!}
    {!! Form::text('predlozhniy', null, ['class' => 'form-control']) !!}
</div>

<!-- Submit Field -->
<div class="form-group col-sm-12">
    {!! Form::submit('Сохранить', ['class' => 'btn btn-primary']) !!}
    <a href="{!! route('microDistricts.index') !!}" class="btn btn-default">Отмена</a>
</div>

resources/views/micro_districts/index.blade.php
@extends('layouts.app')

@section('content')

    @include('layouts.header', ['title' => 'Микрорайоны','link' => 'microDistricts','add'=>'микрорайон'])

    <div class="content">
        <div class="clearfix"></div>

        @include('flash::message')

        <div class="clearfix"></div>
        <div class="box box-primary">
            <div class="box-body">
                    @include('micro_districts.table')
            </div>
        </div>
        <div class="text-center">
        
        </div>
    </div>
@endsection

resources/views/micro_districts/show.blade.php
@extends('layouts.app')

@section('content')
    <section class="content-header">
        <h1>
            Micro District
        </h1>
    </section>
    <div class="content">
        <div class="box box-primary">
            <div class="box-body">
                <div class="row" style="padding-left: 20px">
                    @include('micro_districts.show_fields')
                    <a href="{!! route('microDistricts.index') !!}" class="btn btn-default">Back</a>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/micro_districts/show_fields.blade.php
<!-- Id Field -->
<div class="form-group">
    {!! Form::label('id', 'Id:') !!}
    <p>{!! $microDistrict->id !!}</p>
</div>

<!-- District Id Field -->
<div class="form-group">
    {!! Form::label('district_id', 'District Id:') !!}
    <p>{!! $microDistrict->district_id !!}</p>
</div>

<!-- Micro District Id Field -->
<div class="form-group">
    {!! Form::label('micro_district_id', 'Micro District Id:') !!}
    <p>{!! $microDistrict->micro_district_id !!}</p>
</div>

<!-- Name Field -->
<div class="form-group">
    {!! Form::label('name', 'Name:') !!}
    <p>{!! $microDistrict->name !!}</p>
</div>

<!-- Translit Field -->
<div class="form-group">
    {!! Form::label('translit', 'Translit:') !!}
    <p>{!! $microDistrict->translit !!}</p>
</div>

<!-- Roditelniy Field -->
<div class="form-group">
    {!! Form::label('roditelniy', 'Roditelniy:') !!}
    <p>{!! $microDistrict->roditelniy !!}</p>
</div>

<!-- Predlozhniy Field -->
<div class="form-group">
    {!! Form::label('predlozhniy', 'Predlozhniy:') !!}
    <p>{!! $microDistrict->predlozhniy !!}</p>
</div>

<!-- Created At Field -->
<div class="form-group">
    {!! Form::label('created_at', 'Created At:') !!}
    <p>{!! $microDistrict->created_at !!}</p>
</div>

<!-- Updated At Field -->
<div class="form-group">
    {!! Form::label('updated_at', 'Updated At:') !!}
    <p>{!! $microDistrict->updated_at !!}</p>
</div>

resources/views/micro_districts/table.blade.php
@section('css')
    @include('layouts.datatables_css')
@endsection

{!! $dataTable->table(['width' => '100%']) !!}

@section('scripts')
    @include('layouts.datatables_js')
    {!! $dataTable->scripts() !!}
@endsection

resources/views/micro_districts/upload.blade.php
@extends('layouts.app')

@section('content')

    @include('layouts.upload', ['title_ru' => 'микрорайонами', 'link' => 'microDistricts'])

@endsection